<template>
  <div class="sy_box">
    <div class="sy_right_bg"></div>
    <div class="sy_bottom_bg"></div>
    <div class="sy_title">溯源分析</div>
    <!-- <div class="close" @click="popoutClose('QX')"></div> -->
    <div class="sy_center_bg"></div>

    <div class="form_box">
      <div class="inp_box">
        <span>溯源时间</span>
        <el-date-picker
          v-model="data.date"
          type="datetime"
          style="width: 130px"
          size="large"
          :clearable="false"
          value-format="YYYY-MM-DD HH"
          format="YYYY-MM-DD HH"
          placeholder="选择日期"
        />
        <!--        <el-select v-model="data.SJvalue" class="m-2" size="large">-->
        <!--          <el-option-->
        <!--            v-for="item in optionsSJ"-->
        <!--            :key="item.value"-->
        <!--            :label="item.label"-->
        <!--            :value="item.value"-->
        <!--          />-->
        <!--        </el-select>-->
      </div>
      <div class="inp_box">
        <span>溯源距离</span>
        <el-select v-model="data.JLvalue" class="m-2" size="large">
          <el-option
            v-for="item in optionsJL"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          />
        </el-select>
      </div>
      <div class="button_box">
        <el-button size="small" @click="selectList">确认</el-button>
        <!-- <el-button size="small" @click="FKList">反馈</el-button> -->
        <el-button size="small" @click="WRY" v-show="WRYstate"
          >污染源</el-button
        >
        <el-button size="small" @click="FC" v-show="FCstate">{{
          FCopen ? "关闭风场" : "风场"
        }}</el-button>
        <el-button
          size="small"
          :disabled="data.BTNdisabled"
          @click="SYshow"
          v-show="flyBtnState"
          >飞入</el-button
        >
      </div>
    </div>
  </div>
</template>

<script>
import { reactive, onMounted, watch, ref } from "vue";
import {
  ysshSuYuanX00Controller,
  getCoordByName,
  selectSuYuan46ById,
} from "@/api/api.js";
import { useStore } from "vuex";
import { ElMessage, ElMessageBox } from "element-plus";

export default {
  //import引入的组件需要注入到对象中才能使用
  components: {},
  props: ["SYPOIname"],
  emits: ["toggleFK"],
  setup(props, { emit }) {
    const store = useStore();
    let flyBtnState = ref(false);
    let POIname = ref("");
    let OldPOIname = ref("");
    let data = reactive({
      date: "",
      SJvalue: "vocsValue",
      JLvalue: "100",
      SYPOIname: props.SYPOIname,
      btnIsshow: true,
      BTNdisabled: true,
      x: 0,
      y: 0,
      WGlist: [],
    });
    const selectform = reactive({
      name: "",
    });
    const optionsSJ = reactive([
      {
        value: "vocsValue",
        label: "实时",
      },
      {
        value: "vocsDaily",
        label: "日均",
      },
      {
        value: "vocsMonthly",
        label: "月均",
      },
      {
        value: "vocsAnnual",
        label: "年均",
      },
    ]);
    const optionsJL = reactive([
      {
        value: "100",
        label: "100m",
      },
      {
        value: "200",
        label: "200m",
      },
      // {
      //   value: "300",
      //   label: "300m",
      // },
      // {
      //   value: "500",
      //   label: "500m",
      // },
    ]);
    let WRYstate = ref(false);
    let FCstate = ref(false);
    const selectList = async () => {
      if (POIname.value == "") {
        return ElMessage.error("请点击监控点");
      }
      if (data.date == "") {
        return ElMessage.error("请选择时间");
      }
      data.WGlist = [];
      window.sgworld.Core.postMessage({ type: "delete" });
      //删除风场
      window.sgworld.Core.postMessage("Type=customewinds;Bool=false;");
      //删除连线
      window.sgworld.Core.postMessage({ func_name: "RemoveGridLines", id: "" });
      //删除边界
      window.sgworld.Core.postMessage({ func_name: "RemoveGridSide", id: "" });
      // const dt = await ysshSuYuanX00Controller(
      //   { name: store.state.POIname },
      //   data.JLvalue
      // );

      const dt = await ysshSuYuanX00Controller(
        { name: store.state.POIname, date: data.date + ":00:00" },
        data.JLvalue
      );
      if (dt.result) {
        data.feedbackId = dt.result.feedbackId;
        data.WGlist = dt.result.data;
        let h = 450;
        WRYstate.value = true;
        FCstate.value = true;
        let arr = [];
        dt.result.data.forEach((e) => {
          arr.push({
            id: e.id,
            name: e.vocsName,
            vocs: e.vocsValue,
            // vocs: e[data.SJvalue],
            tm: 2,
            lon: e.lon,
            lat: e.lat,
            high: 300,
            vc: "E9FF00FF",
            nc: "FFFFFFFF",
            bool: false,
            b: true,
            x: e.windDirection,
            f: e.windSpeed,
            Time: data.date + ":00:00",
          });
        });
        sgworld.Core.postMessage({
          type: "newgezi",
          geziarr: arr,
        });
        if (data.JLvalue == 200) {
          h = 500;
        }
        const dt1 = await getCoordByName(store.state.POIname);
        sgworld.Navigate.flyToPosition(dt1.result.lon, dt1.result.lat, h, {
          heading: 270,
          pitch: -89.5,
          roll: 0,
        });
        data.btnIsshow = true;
        data.BTNdisabled = false;
      } else {
        WRYstate.value = false;
        FCstate.value = false;
        FCopen.value = false;
        ElMessage.error("请检查是否有数据");
      }
    };
    const FKList = () => {
      ElMessageBox.confirm("判断溯源是否正确?", "溯源反馈", {
        confirmButtonText: "是",
        cancelButtonText: "否",
        type: "warning",
      })
        .then(() => {
          emit("toggleFK", {
            isShow: false,
            SJvalue: data.SJvalue,
            JLvalue: data.JLvalue,
            SYPOIname: data.SYPOIname,
            date: data.date + ":00:00",
          });
        })
        .catch(() => {
          emit("toggleFK", {
            isShow: true,
            SJvalue: data.JLvalue,
            JLvalue: data.JLvalue,
            SYPOIname: data.SYPOIname,
            date: data.date + ":00:00",
          });
        });
    };
    const SYshow = () => {
      sgworld.Core.postMessage({
        func_name: "ClickAndFlyto",
        Length: "10000",
      });
      // sgworld.Navigate.flyToPosition(
      //   store.state.WGobj.lon,
      //   store.state.WGobj.lat,
      //   120,
      //   {
      //     heading: 270,
      //     pitch: -89.5,
      //     roll: 0,
      //   }
      // );
      // data.btnIsshow = !data.btnIsshow;
      // let isShow = "hide";
      // if (data.btnIsshow) {
      //   isShow = "show";
      // }
      // sgworld.Core.postMessage({ type: "yc", Hs: isShow });
    };
    const WRY = () => {
      data.WGlist.forEach(async (e) => {
        const dt = await selectSuYuan46ById({
          id: e.id,
          date: data.date + ":00:00",
        });
        if (dt.result) {
          sgworld.Core.postMessage({
            func_name: "RemoveGridLines",
            id: "line",
          });
          //删除边界
          sgworld.Core.postMessage({
            func_name: "RemoveGridSide",
            id: "boundary",
          });
          var location = [];
          if (dt.result.x1) {
            location.push({
              lon: dt.result.x1,
              lat: dt.result.y1,
              alt: 150,
              Odds: dt.result.odds1,
              Addr: dt.result.addr1,
            });
          }
          if (dt.result.x2) {
            location.push({
              lon: dt.result.x2,
              lat: dt.result.y2,
              alt: 150,
              Odds: dt.result.odds2,
              Addr: dt.result.addr2,
            });
          }
          if (dt.result.x3) {
            location.push({
              lon: dt.result.x3,
              lat: dt.result.y3,
              alt: 150,
              Odds: dt.result.odds3,
              Addr: dt.result.addr3,
            });
          }
          sgworld.Core.postMessage({
            func_name: "SpawnGridLines",
            StartPointArr: location,
            EndPoint: { endlon: e.lon, endlat: e.lat, endalt: 150 },
            id: "line",
            scale: 30,
            speed: 0.6,
            color: "#ff0000",
            color_strength: 2.0,
            fx_number: 20,
            line_scale: 0.5,
          });
        }
      });
    };
    let FCopen = ref(false);
    const FC = () => {
      if (FCopen.value) {
        window.sgworld.Core.postMessage("Type=customewinds;Bool=false;");
        FCopen.value = false;
      } else {
        window.sgworld.Core.postMessage("Type=customewinds;Bool=false;");
        window.sgworld.Core.postMessage(
          `Type=customewinds;Bool=true;Year=${data.date.slice(
            0,
            4
          )};Mouth=${data.date.slice(5, 7)};Day=${data.date.slice(
            8,
            10
          )};Hour=${data.date.slice(11, 13)};Density=${BJFC.Density};Speed=${
            BJFC.Speed
          };d1=0;d2=30;Corp=1;Lon=${store.state.SYPOI.lon};Lat=${
            store.state.SYPOI.lat
          };Length=${BJFC.Length};`
        );
        FCopen.value = true;
      }
    };
    watch(
      () => store.state.POIname,
      (nVal, oVal) => {
        POIname.value = nVal;
        OldPOIname.value = oVal;
        data.btnIsshow = true;
        data.BTNdisabled = true;
      },

      { deep: true, immediate: true }
    );
    watch(
      () => store.state.WGobj,
      (nVal, oVal) => {
        if (nVal !== null) {
          flyBtnState.value = true;
        } else {
          flyBtnState.value = false;
        }
      },

      { deep: true, immediate: true }
    );
    onMounted(() => {});
    return {
      data,
      selectform,
      selectList,
      optionsSJ,
      optionsJL,
      FKList,
      SYshow,
      flyBtnState,
      WRY,
      WRYstate,
      FCstate,
      FC,
      FCopen,
    };
  },
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.sy_box {
  // width: calc(742px * 1.5);
  height: calc(200px * 1);
  // position: absolute;
  // right: 70px;
  // top: 1130px;
  background: url("../assets/img/d.png") no-repeat center;
  background-size: 100% 100%;
  padding: 40px;
  box-sizing: border-box;
  .sy_title {
    font-size: 30px;
    font-weight: bold;
    color: #ffffff;
    padding-bottom: 10px;
  }
}
.form_box {
  display: flex;
  justify-content: space-around;
  align-items: center;
  .inp_box {
    display: flex;
    align-items: center;
    margin-right: 25px;
    span {
      font-size: 24px;
      font-weight: 400;
      color: #ffffff;
      padding-right: 10px;
    }
    :deep(.el-select) {
      width: 140px;
      height: 64px;
    }
    .el-select /deep/ .el-input__wrapper {
      background: rgba(0, 0, 0, 0.2);
      border: 2px solid #2e58cc;
      border-radius: 10px;
      color: #ffffff;
      padding: 0;
      padding-left: 3px;
      height: 64px;
    }
    .el-select /deep/ .el-input__inner {
      color: #ffffff;
      font-size: 24px;
    }
  }
  .el-button {
    background: rgba(0, 0, 0, 0.2);
    border: 4px solid #2e58cc !important;
    border-radius: 20px !important;
    color: #ffffff;
    height: 64px !important;
    font-size: 24px !important;
    padding: 16px 30px !important;
  }
  .el-button:focus,
  .el-button:hover {
    color: var(--el-button-hover-text-color);
    border-color: var(--el-button-hover-border-color);
    background-color: var(--el-button-hover-bg-color);
    outline: 0;
  }
}
</style>
